package com.gmail.pedrolucasnascimentoc;


import java.util.Iterator;

import org.bukkit.Bukkit;
import org.bukkit.Effect;
import org.bukkit.entity.Player;
import org.bukkit.entity.Vehicle;
import org.bukkit.map.MapView;

import com.bergerkiller.bukkit.tc.controller.MinecartGroup;
import com.bergerkiller.bukkit.tc.controller.MinecartMember;
import com.gmail.pedrolucasnascimentoc.render.Renderizador;


public class Locomotiva {
	MapView mapa;
	int direcao = 0;
	boolean hep = false;
	boolean luz = false;
	boolean[] luzInterna;
	boolean compressor;
	double pressaoTambor = 40;
	double cargaBateria = 20.0;
	int posicao = 0;
	int potencia = 0;
	Aceleracao acelerador;
	Desaceleracao freio;
	Compressor comprime;
	Mantem continua;
	Renderizador render;
	boolean parado = true;
	double consumo;
	int capacidadeCombustivel = 0;
	boolean baixaVoltagem = false;
	boolean altaVoltagem = false;
	int voltagem;
	int[] formacaoVisivel;
	int[] formacaoVirtual;
	boolean eletrica;
	int tamanho;
	double aceleracaoMaxima;
	MinecartMember[] formacaoMinecartMember;
	MinecartMember[] carrosMotores;
	MinecartMember[] tanquesCombustivel;
	public static MinecartEngine plugin;
	MinecartGroup locomotiva;

	Locomotiva(MinecartGroup locomotiva, boolean eletrica, int voltagem, MinecartEngine plugin) {
		this.acelerador = new Aceleracao();
		this.freio = new Desaceleracao();
		this.plugin = plugin;
		this.continua = new Mantem();
		this.locomotiva = locomotiva;
		this.eletrica = eletrica;
		this.formacaoMinecartMember = this.locomotiva.toArray();
		this.tamanho = formacaoMinecartMember.length;
		this.formacaoVisivel = new int[tamanho];
		this.formacaoVirtual = new int[tamanho];
		this.luzInterna = new boolean[tamanho];
		int quantMotores = 0;
		int quantCombustivel = 0;
		for(int i = 0; i <= (tamanho - 1); i++) {
			formacaoVisivel[i] = 0;
			if(formacaoMinecartMember[i].isStorageCart()) {
				quantCombustivel++;
				formacaoVisivel[i] = 1;
				this.capacidadeCombustivel = this.capacidadeCombustivel + 27;
			} else if(formacaoMinecartMember[i].isPoweredCart()) {
				quantMotores++;
				formacaoVisivel[i] = 2;
				this.potencia = this.potencia + 500;
			}
		}
		this.tanquesCombustivel = new MinecartMember[quantCombustivel];
		this.carrosMotores = new MinecartMember[quantMotores];
		quantMotores = 0;
		quantCombustivel = 0;
		for(int i = 0; i <= (tamanho - 1); i++) {
			if(formacaoMinecartMember[i].isStorageCart()) {
				this.tanquesCombustivel[quantCombustivel] = formacaoMinecartMember[i];
				quantCombustivel++;
			} else if(formacaoMinecartMember[i].isPoweredCart()) {
				this.carrosMotores[quantMotores] = formacaoMinecartMember[i];
				quantMotores++;
			}
		}
		boolean jaTemPantografo = false;
		for(int i = 0; i <= (tamanho - 1); i++) {
			formacaoVirtual[i] = formacaoVisivel[i];
			if (formacaoVisivel[i] == 0 && i == 0) {
				formacaoVirtual[i] = 4;
			} else if (formacaoVisivel[i] == 0 && i == (tamanho - 1)) {
				formacaoVirtual[i] = 4;
			} else if (formacaoVisivel[i] == 2 && !jaTemPantografo && this.eletrica) {
				formacaoVirtual[i] = 3;
				jaTemPantografo = true;
			}
		}
		this.aceleracaoMaxima = (40 * 500) / this.potencia;
		if(eletrica) {
			this.voltagem = voltagem;		
			capacidadeCombustivel = 0;
			this.consumo = (this.potencia * 0.07) + this.potencia;
		}
	}

	public boolean ligaDesligaTrem() {
		if(this.baixaVoltagem && !this.altaVoltagem) {
			this.altaVoltagem = true;
			return true;
		} else if(!this.baixaVoltagem) {
			return false;
		} else if(this.baixaVoltagem && this.altaVoltagem) {
			this.altaVoltagem = false;
			return true;
		}
		return false;
	}

	public void aplicaNeutro(Player jogador) { 
		encerraTudo();
		if(this.posicao < 0) {
			tcha();
			this.pressaoTambor = this.pressaoTambor - (Math.abs(this.posicao) * 0.4);
			if(this.pressaoTambor < 30) {
				boolean vai = false;
				try {
					vai = comprime.isRoda();
				} catch (Exception e) {
				}
				if(!vai) {
					comprime = new Compressor(this);
					comprime.start();
				}
			}
		}
		if(this.posicao != 0) {
			locomotiva.getWorld().playEffect(jogador.getLocation(), Effect.DOOR_TOGGLE, 0);
		}
		this.posicao = 0;
		//this.freio = new Desaceleracao();
		//this.freio.SetDesaceleracao(30, this.locomotiva.getAverageForce(), 25, 1, locomotiva, jogador, false);
		//this.freio.start();
	}

	public void aplicaPonto(int ponto, Player jogador) { 
		encerraTudo();
		if(this.posicao < 0) {
			tcha();
			this.pressaoTambor = this.pressaoTambor - (Math.abs(this.posicao) * 0.4);
			if(this.pressaoTambor < 30) {
				boolean vai = false;
				try {
					vai = comprime.isRoda();
				} catch (Exception e) {
				}
				if(!vai) {
					comprime = new Compressor(this);
					comprime.start();
				}
			}
		}
		if(ponto != this.posicao) {
			locomotiva.getWorld().playEffect(jogador.getLocation(), Effect.DOOR_TOGGLE, 0);
		}
		if(this.altaVoltagem) {
			this.posicao = ponto;
			double aAplicar = 0;
			if(ponto == 1) {
				aAplicar = 0.2;
			} else if(ponto == 2) {
				aAplicar = 0.5;
			} else if(ponto == 3) {
				aAplicar = 0.7;
			} else if(ponto == 4) {
				aAplicar = 1;
			}
			this.acelerador = new Aceleracao();
			this.acelerador.SetAceleracao(aAplicar, this.locomotiva.getAverageForce(), (double) 1, (int) this.aceleracaoMaxima, this.locomotiva, this.direcao, jogador);
			this.acelerador.start();
		}
	}


	public void aplicaFreio(int ponto, Player jogador) {
		encerraTudo();
		if(this.posicao < (0 - ponto)) {
			tcha();
			this.pressaoTambor = this.pressaoTambor - ((Math.abs(this.posicao) - ponto) * 0.4);
			if(this.pressaoTambor < 30) {
				boolean vai = false;
				try {
					vai = comprime.isRoda();
				} catch (Exception e) {
				}
				if(!vai) {
					comprime = new Compressor(this);
					comprime.start();
				}
			}
		}
		if((0 - ponto) != this.posicao) {
			locomotiva.getWorld().playEffect(jogador.getLocation(), Effect.DOOR_TOGGLE, 0);
		}
		this.posicao = (0 - ponto);
		double fator = 0;
		if(ponto == 1) {
			fator = 50;
		} else if(ponto == 2) {
			fator = 100;
		} else if(ponto == 3) {
			fator = 150;
		} else if(ponto == 4) {
			fator = 200;
		} 
		this.freio = new Desaceleracao();
		this.freio.SetDesaceleracao(fator, this.locomotiva.getAverageForce(), 25, 1, locomotiva, jogador, true);
		this.freio.start();
	}

	public static Locomotiva pegaLocomotiva(Player jogador) {
		Locomotiva instanciaLocomotiva = null;
		MinecartGroup tremDaLocomotiva = null;
		MinecartGroup tremDoJogador = null;
		Iterator passa = plugin.getLocomotivas().iterator();
		while(passa.hasNext()) {
			instanciaLocomotiva = ((Locomotiva) passa.next());
			tremDaLocomotiva = instanciaLocomotiva.getLocomotiva();
			tremDoJogador = MinecartGroup.get(jogador.getVehicle());
			if(tremDaLocomotiva.contains(tremDoJogador.get(0))) {
				return instanciaLocomotiva;
			}
		}
		return instanciaLocomotiva;
	}
	
	public static Locomotiva pegaLocomotiva(Vehicle carrinho) {
		Locomotiva instanciaLocomotiva = null;
		MinecartGroup tremDaLocomotiva = null;
		MinecartGroup tremDoJogador = null;
		Iterator passa = plugin.getLocomotivas().iterator();
		while(passa.hasNext()) {
			instanciaLocomotiva = ((Locomotiva) passa.next());
			tremDaLocomotiva = instanciaLocomotiva.getLocomotiva();
			tremDoJogador = MinecartGroup.get(carrinho);
			if(tremDaLocomotiva.contains(tremDoJogador.get(0))) {
				return instanciaLocomotiva;
			}
		}
		return instanciaLocomotiva;
	}
	
	public static Locomotiva pegaLocomotiva(MinecartMember carrinho) {
		Player eu = Bukkit.getPlayer("ClaudeSpeedIII");
		
		Locomotiva instanciaLocomotiva = null;
		MinecartGroup tremDaLocomotiva = null;
		Iterator passa = plugin.getLocomotivas().iterator();
		while(passa.hasNext()) {
			instanciaLocomotiva = ((Locomotiva) passa.next());
			tremDaLocomotiva = instanciaLocomotiva.getLocomotiva();
			if(tremDaLocomotiva.contains(carrinho)) {
				return instanciaLocomotiva;
			}
		}
		eu.sendMessage(instanciaLocomotiva.getLocomotiva().toString());
		return instanciaLocomotiva;
	}

	public boolean ligaTrem() {
		if(this.cargaBateria > 3) {
			this.baixaVoltagem = true;
			return true;
		} else {
			return false;
		}
	}

	public boolean desligaTrem() {
		if(!this.altaVoltagem) {
			this.baixaVoltagem = false;
			return true;
		} else {
			return false;
		}
	}


	private void encerraTudo() {
		try {
			this.continua = acelerador.getinstancia_mantem();
			this.acelerador.ParaThread();
		} catch (Exception e) {
		}
		try {
			this.continua.ParaThread();
		} catch (Exception e) {
		}
		try {
			this.freio.ParaThread();
		} catch (Exception e) {
		}
		this.parado = false;
	}

	public void mapa(Player entered) {
		Renderizador.locomotiva = this;
		Renderizador.principal = this.plugin;
		this.render = new Renderizador();
		mapa = entered.getServer().getMap((short) 0);
		mapa.addRenderer(this.render);
		entered.sendMap(mapa);
	}

	public void tcha() {
		for(int i = 0; i <= (tamanho - 1); i++){ 
			locomotiva.getWorld().playEffect(this.formacaoMinecartMember[i].getLocation(), Effect.EXTINGUISH, 0);
		}
	}

	synchronized public MinecartMember[] getCarrosMotores() {
		return carrosMotores;
	}

	synchronized public MinecartMember[] getTanquesCombustivel() {
		return tanquesCombustivel;
	}

	public void setDirecao(int direcao, Player jogador) {
		if(this.direcao != direcao) {
			this.direcao = direcao;
			locomotiva.getWorld().playEffect(jogador.getLocation(), Effect.DOOR_TOGGLE, 0);			
		}
	}	

	synchronized public void setPressaoTambor(double pressaoTambor) {
		this.pressaoTambor = pressaoTambor;
	}

	public int getDirecao() {
		return direcao;
	}

	public boolean isHep() {
		return hep;
	}

	public boolean isLuz() {
		return luz;
	}

	public boolean[] getLuzInterna() {
		return luzInterna;
	}

	synchronized public double getPressaoTambor() {
		return pressaoTambor;
	}

	public double getCargaBateria() {
		return cargaBateria;
	}

	public int getPosicao() {
		return posicao;
	}

	public int getPotencia() {
		return potencia;
	}

	public double getConsumo() {
		return consumo;
	}

	public int getCapacidadeCombustivel() {
		return capacidadeCombustivel;
	}

	public boolean isBaixaVoltagem() {
		return baixaVoltagem;
	}

	public boolean isAltaVoltagem() {
		return altaVoltagem;
	}

	public int getVoltagem() {
		return voltagem;
	}

	public int[] getFormacaoVisivel() {
		return formacaoVisivel;
	}

	public int[] getFormacaoVirtual() {
		return formacaoVirtual;
	}

	public boolean isEletrica() {
		return eletrica;
	}

	public int getTamanho() {
		return tamanho;
	}

	public MinecartMember[] getFormacaoMinecartMember() {
		return formacaoMinecartMember;
	}

	public MinecartGroup getLocomotiva() {
		return locomotiva;
	}

	public boolean isParado() {
		return parado;
	}

	public void setParado(boolean parado) {
		this.parado = parado;
	}






}

