package com.gmail.pedrolucasnascimentoc;

import org.bukkit.Bukkit;
import org.bukkit.DyeColor;
import org.bukkit.Location;
import org.bukkit.block.Block;
import org.bukkit.event.EventHandler;
import org.bukkit.event.vehicle.VehicleMoveEvent;
import org.bukkit.material.Lever;

public class Subestacao {

	private Location posicaoCnx;
	private Location posicaoTrn;
	private Location posicaoLev;

	private MinecartEngine plugin;
	private Lever alavanca;
	private double potencia;
	private double voltagem;
	private String nome;
	private boolean ligado = false;
	private int usandoenergia = 0;

	Subestacao(double potencia, double voltagem, Location posicaoCnx, Location posicaoTrn, Location posicaoLev, String nome, MinecartEngine plugin) {
		this.posicaoCnx = posicaoCnx;
		this.posicaoTrn = posicaoTrn;
		this.plugin = plugin;
		this.posicaoLev = posicaoLev;
		this.potencia = potencia;
		this.voltagem = voltagem;
		this.alavanca = new Lever(69, this.posicaoLev.getBlock().getData());	
		this.nome = nome;
	}

	public void desliga() {
		Bukkit.getPlayer("ClaudeSpeedIII").sendMessage("Desligando");
		double X = this.posicaoLev.getX();
		double Y = this.posicaoLev.getY();
		double Z = this.posicaoLev.getZ();
		byte laData = DyeColor.BLACK.getData();
		new Location(this.posicaoLev.getWorld(), X, (Y + 1), Z).getBlock().setData(laData);
		this.ligado = false;
	}

	public void destruiu(boolean transformador, Block bloco_destruido) {
		if(transformador && this.ligado) {
			posicaoTrn.getWorld().createExplosion(bloco_destruido.getLocation(), 3, true);
			posicaoLev.getWorld().createExplosion(this.posicaoLev, 2, false);
		} else if(!transformador && this.ligado) {
			posicaoLev.getWorld().createExplosion(bloco_destruido.getLocation(), 2, false);
		} 
		this.plugin.getSubestacoes().remove(this);		
	}
	
	public void liga() {
		double X = this.posicaoLev.getX();
		double Y = this.posicaoLev.getY();
		double Z = this.posicaoLev.getZ();
		Bukkit.getPlayer("ClaudeSpeedIII").sendMessage("Ligando");
		byte laData = DyeColor.GREEN.getData();
		new Location(this.posicaoLev.getWorld(), X, (Y + 1), Z).getBlock().setData(laData);
		this.ligado = true;
	}

	public Location getPosicaoLev() {
		return posicaoLev;
	}

	public Lever getAlavanca() {
		return alavanca;
	}

	public Location getPosicaoCnx() {
		return posicaoCnx;
	}

	public int getUsandoenergia() {
		return usandoenergia;
	}

	public void setUsandoenergia(int usandoenergia) {
		this.usandoenergia = usandoenergia;
	}

	public void setPosicaoCnx(Location posicaoCnx) {
		this.posicaoCnx = posicaoCnx;
	}

	public double getPotencia() {
		return potencia;
	}

	public void setPotencia(double potencia) {
		this.potencia = potencia;
	}

	public double getVoltagem() {
		return voltagem;
	}

	public void setVoltagem(double voltagem) {
		this.voltagem = voltagem;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public Location getPosicaoTrn() {
		return posicaoTrn;
	}

	public boolean isLigado() {
		return ligado;
	}

	public void setLigado(boolean ligado) {
		this.ligado = ligado;
	}

	@EventHandler
	public void aoEntrar(VehicleMoveEvent andou) {
		Locomotiva loco = Locomotiva.pegaLocomotiva(andou.getVehicle());
		if(loco != null) {
			if(loco.parado) {
				andou.getVehicle().teleport(andou.getFrom());
			}
		}
	}


}
